/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { XYChart } from "./XYChart";
import { CategoryChartType_$type } from "./CategoryChartType";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { TransitionInSpeedType_$type } from "./TransitionInSpeedType";
import { CategoryXAxis } from "./CategoryXAxis";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { DataSeriesType_$type } from "igniteui-react-core/ES2015/DataSeriesType";
import { NumericYAxis } from "./NumericYAxis";
import { IDataSeriesAdapterRule_$type } from "igniteui-react-core/ES2015/IDataSeriesAdapterRule";
import { SimpleCategorySeriesRule } from "igniteui-react-core/ES2015/SimpleCategorySeriesRule";
import { SubCollectionsRule } from "igniteui-react-core/ES2015/SubCollectionsRule";
import { Brush } from "igniteui-react-core/ES2015/Brush";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { ArrayExtension } from "igniteui-react-core/ES2015/ArrayExtension";
import { typeCast, runOn, delegateCombine, enumGetBox, markType, TypeRegistrar } from "igniteui-react-core/ES2015/type";
import { AxisLabelSettings } from "./AxisLabelSettings";
export class CategoryChart extends XYChart {
    constructor() {
        super();
        this.ob = 1000;
        this.nj = null;
        this.m4 = 9;
        this.m6 = 1;
        this.nl = false;
        this.m8 = 0;
        this.nh = 0;
        this.ns = 0;
        this.nt = 0;
        this.nr = 0;
        this.nu = 0;
        this.nv = NaN;
        this.nn = false;
        this.oc = 10;
        this.nx = NaN;
        this.nw = NaN;
        this.ny = 0;
        this.m0 = null;
        this.m1 = null;
        this.nm = true;
        this.ep();
    }
    e2() {
        super.e2();
        if (this.dataChart == null) {
            return;
        }
        let a = this.dataChart.bl.i.e();
        this.m2 = a.d;
        this.m3 = a.e;
        this.mj = this.mc = a.k;
    }
    e4(a, b) {
        super.e4(a, b);
        a.ff = this.od;
        a.bv = this.nk;
    }
    fl(a, b, c) {
        super.fl(a, b, c);
        switch (a) {
            case "TransitionInDuration":
                this.o0((d) => d.ff = this.od);
                break;
            case "TransitionInEasingFunction":
                this.o0((d) => d.bv = this.nk);
                break;
        }
    }
    get od() {
        return this.ob;
    }
    set od(a) {
        let b = this.od;
        if (a != b) {
            this.ob = a;
            this.fk("TransitionInDuration", b, this.od);
        }
    }
    get nk() {
        return this.nj;
    }
    set nk(a) {
        let b = this.nk;
        if (a != b) {
            this.nj = a;
            this.fk("TransitionInEasingFunction", b, this.nk);
        }
    }
    og() {
        let cvd_ = this.co();
        cvd_.scaleByViewport();
        return (cvd_.serialize());
    }
    ex(a) {
        super.ex(a);
        a.cb = this.av;
    }
    e3(a, b) {
        super.e3(a, b);
        let c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c == null) {
            return;
        }
        c.oq = this.m7;
        c.np = this.no;
        c.m8 = this.m9;
        c.bp = this.ni;
        c.trendLineBrush = ArrayExtension.getModulus$1(Brush.$, this.o, b);
        c.trendLineType = this.ai;
        c.trendLineThickness = this.cb;
        c.ls = this.ad(a, b);
        if (a.cz) {
            a.i9(ArrayExtension.getModulus$1(Brush.$, this.m2, b), ArrayExtension.getModulus$1(Brush.$, this.m3, b));
        }
    }
    na() {
        return new CategoryXAxis();
    }
    nf() {
        return new NumericYAxis();
    }
    en() {
        this.xAxis = this.na();
        this.xAxis.name = "xAxis";
        let a = this.xAxis;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.o2));
        this.yAxis = this.nf();
        this.yAxis.name = "yAxis";
        let b = this.yAxis;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.o3));
        if (this.xAxis.aw == null) {
            this.xAxis.aw = new AxisLabelSettings();
        }
        if (this.yAxis.aw == null) {
            this.yAxis.aw = new AxisLabelSettings();
        }
    }
    li(a) {
        super.li(a);
        a.jh = this.np;
    }
    get m5() {
        return this.m4;
    }
    set m5(a) {
        if (a != this.m4) {
            let b = this.m5;
            this.m4 = a;
            this.fk("ChartType", enumGetBox(CategoryChartType_$type, b), enumGetBox(CategoryChartType_$type, this.m5));
        }
    }
    get m7() {
        return this.m6;
    }
    set m7(a) {
        let b = this.m7;
        if (a != b) {
            this.m6 = a;
            this.fk("MarkerCollisionAvoidance", enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, b), enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, this.m7));
        }
    }
    get no() {
        return this.nl;
    }
    set no(a) {
        let b = this.no;
        if (a != b) {
            this.nl = a;
            this.fk("IsTransitionInEnabled", b, this.no);
        }
    }
    get m9() {
        return this.m8;
    }
    set m9(a) {
        let b = this.m9;
        if (a != b) {
            this.m8 = a;
            this.fk("TransitionInMode", enumGetBox(CategoryTransitionInMode_$type, b), enumGetBox(CategoryTransitionInMode_$type, this.m9));
        }
    }
    get ni() {
        return this.nh;
    }
    set ni(a) {
        let b = this.ni;
        if (a != b) {
            this.nh = a;
            this.fk("TransitionInSpeedType", enumGetBox(TransitionInSpeedType_$type, b), enumGetBox(TransitionInSpeedType_$type, this.ni));
        }
    }
    get n2() {
        return this.ns;
    }
    set n2(a) {
        let b = this.n2;
        if (a != b) {
            this.ns = a;
            this.fk("XAxisInterval", b, this.n2);
        }
    }
    get n3() {
        return this.nt;
    }
    set n3(a) {
        let b = this.n3;
        if (a != b) {
            this.nt = a;
            this.fk("XAxisMinorInterval", b, this.n3);
        }
    }
    get n1() {
        return this.nr;
    }
    set n1(a) {
        let b = this.n1;
        if (a != b) {
            this.nr = a;
            this.fk("XAxisGap", b, this.n1);
        }
    }
    get n4() {
        return this.nu;
    }
    set n4(a) {
        let b = this.n4;
        if (a != b) {
            this.nu = a;
            this.fk("XAxisOverlap", b, this.n4);
        }
    }
    get n7() {
        return this.nv;
    }
    set n7(a) {
        let b = this.n7;
        if (a != b) {
            this.nv = a;
            this.fk("YAxisInterval", b, this.n7);
        }
    }
    get nq() {
        return this.nn;
    }
    set nq(a) {
        let b = this.nq;
        if (a != b) {
            this.nn = a;
            this.fk("YAxisIsLogarithmic", b, this.nq);
        }
    }
    get oe() {
        return this.oc;
    }
    set oe(a) {
        let b = this.oe;
        if (a != b) {
            this.oc = a;
            this.fk("YAxisLogarithmBase", b, this.oe);
        }
    }
    get n9() {
        return this.nx;
    }
    set n9(a) {
        let b = this.n9;
        if (a != b) {
            this.nx = a;
            this.fk("YAxisMinimumValue", b, this.n9);
        }
    }
    get n8() {
        return this.nw;
    }
    set n8(a) {
        let b = this.n8;
        if (a != b) {
            this.nw = a;
            this.fk("YAxisMaximumValue", b, this.n8);
        }
    }
    get oa() {
        return this.ny;
    }
    set oa(a) {
        let b = this.oa;
        if (a != b) {
            this.ny = a;
            this.fk("YAxisMinorInterval", b, this.oa);
        }
    }
    get n0() {
        return this.xAxis.k4;
    }
    get nz() {
        return this.xAxis.k3;
    }
    get n6() {
        return this.yAxis.jx;
    }
    get n5() {
        return this.yAxis.jw;
    }
    get m2() {
        return this.m0;
    }
    set m2(a) {
        let b = this.m2;
        if (a != b) {
            this.m0 = a;
            this.fk("NegativeBrushes", b, this.m2);
        }
    }
    get m3() {
        return this.m1;
    }
    set m3(a) {
        let b = this.m3;
        if (a != b) {
            this.m1 = a;
            this.fk("NegativeOutlines", b, this.m3);
        }
    }
    get np() {
        return this.nm;
    }
    set np(a) {
        let b = this.np;
        if (a != b) {
            this.nm = a;
            this.fk("YAxisAbbreviateLargeNumbers", b, this.np);
        }
    }
    get_bb() {
        let a = new List$1(DataSeriesType_$type, 0);
        if (TypeRegistrar.isRegistered("AreaSeries")) {
            a.add(2);
        }
        if (TypeRegistrar.isRegistered("ColumnSeries")) {
            a.add(1);
        }
        if (TypeRegistrar.isRegistered("LineSeries")) {
            a.add(0);
        }
        if (TypeRegistrar.isRegistered("PointSeries")) {
            a.add(10);
        }
        if (TypeRegistrar.isRegistered("SplineSeries")) {
            a.add(6);
        }
        if (TypeRegistrar.isRegistered("SplineAreaSeries")) {
            a.add(7);
        }
        if (TypeRegistrar.isRegistered("StepAreaSeries")) {
            a.add(5);
        }
        if (TypeRegistrar.isRegistered("StepLineSeries")) {
            a.add(4);
        }
        if (TypeRegistrar.isRegistered("WaterfallSeries")) {
            a.add(8);
        }
        return a;
    }
    get bb() {
        return this.get_bb();
    }
    o2(a, b) {
        switch (b.propertyName) {
            case "ActualMinimum":
                this.fq("XAxisActualMinimum");
                break;
            case "ActualMaximum":
                this.fq("XAxisActualMaximum");
                break;
        }
    }
    o3(a, b) {
        switch (b.propertyName) {
            case "ActualMinimumValue":
                this.fq("YAxisActualMinimum");
                break;
            case "ActualMaximumValue":
                this.fq("YAxisActualMaximum");
                break;
        }
    }
    f1() {
        super.f1();
        this.xAxis.e2 = this.i2 == null ? XYChart.ja(this.xAxis, this.s.dataSeries) : this.i2;
        this.xAxis.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
    }
    get xAxis() {
        return this._xAxis;
    }
    set xAxis(a) {
        this._xAxis = a;
    }
    get yAxis() {
        return this._yAxis;
    }
    set yAxis(a) {
        this._yAxis = a;
    }
    nc(seriesType_) {
        return (this.externalObject.createSeries(seriesType_).i);
    }
    ne(a, b) {
        switch (a) {
            case 2: return this.nc(1);
            case 3: return this.nc(10);
            case 0: return this.nc(0);
            case 1: return this.nc(2);
            case 6: return this.nc(6);
            case 7: return this.nc(7);
            case 4: return this.nc(4);
            case 5: return this.nc(5);
            case 8: return this.nc(8);
            case 9: return this.nd(b);
            default: return this.nc(1);
        }
    }
    nd(a) {
        return this.nc(a);
    }
    r(a) {
        switch (this.m5) {
            case 1: return 2;
            case 0: return 0;
            case 3: return 10;
            case 6: return 6;
            case 7: return 7;
            case 5: return 5;
            case 4: return 4;
            case 8: return 8;
            case 9: return a.suggestedSeries;
            default:
            case 2: return 1;
        }
    }
    ag(a, b) {
        let c = this.ne(this.m5, a.suggestedSeries);
        c.o3 = a.findMatchingHint(0).path;
        c.xAxis = this.xAxis;
        c.yAxis = this.yAxis;
        return c;
    }
    fz(a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.jm = true;
            this.yAxis.j9 = 10;
        }
    }
    f2() {
        this.yAxis.jm = this.nq;
        this.yAxis.j9 = this.oe;
    }
    f4(a) {
        super.f4(a);
        let b = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (b == null) {
            return;
        }
        b.xAxis = null;
        b.yAxis = null;
    }
    get_ba() {
        return ((() => {
            let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleCategorySeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    }
    get ba() {
        return this.get_ba();
    }
    el(a, b) {
        let c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c != null) {
            c.oq = this.m7;
            c.ls = this.ad(a, b);
        }
    }
    o0(a) {
        this.o1((b, c) => a(b));
    }
    o1(a) {
        if (this.dataChart == null) {
            return;
        }
        for (let b = 0; b < this.dataChart.series.count; b++) {
            a(typeCast(HorizontalAnchoredCategorySeries.$, this.dataChart.series._inner[b]), b);
        }
    }
    gm() {
        return this.xAxis;
    }
    gn() {
        return this.yAxis;
    }
    fk(a, b, c) {
        super.fk(a, b, c);
        switch (a) {
            case "ChartType":
                this.f1();
                break;
            case "MarkerCollisionAvoidance":
                this.o0((d) => d.oq = this.m7);
                break;
            case "IsTransitionInEnabled":
                this.o0((d) => d.np = this.no);
                break;
            case "TransitionInMode":
                this.o0((d) => d.m8 = this.m9);
                break;
            case "TransitionInSpeedType":
                this.o0((d) => d.bp = this.ni);
                break;
            case "XAxisInterval":
                this.xAxis.kz = this.n2;
                break;
            case "XAxisMinorInterval":
                this.xAxis.k0 = this.n3;
                break;
            case "XAxisGap":
                this.xAxis.jh = this.n1;
                break;
            case "XAxisOverlap":
                this.xAxis.jo = this.n4;
                break;
            case "YAxisInterval":
                this.yAxis.j1 = this.n7;
                break;
            case "YAxisIsLogarithmic":
                this.yAxis.jm = this.nq;
                break;
            case "YAxisLogarithmBase":
                this.yAxis.j9 = this.oe;
                break;
            case "YAxisMinimumValue":
                this.yAxis.j5 = this.n9;
                break;
            case "YAxisMaximumValue":
                this.yAxis.j4 = this.n8;
                break;
            case "YAxisMinorInterval":
                this.yAxis.j6 = this.oa;
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.o1((d, e) => {
                    if (d.cz) {
                        d.i9(ArrayExtension.getModulus$1(Brush.$, this.m2, e), ArrayExtension.getModulus$1(Brush.$, this.m3, e));
                    }
                });
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.lo((d) => d.jh = this.np);
                break;
        }
    }
}
CategoryChart.$t = markType(CategoryChart, 'CategoryChart', XYChart.$);
