import { INotifyPropertyChanged, IEnumerable, Type, PropertyChangedEventArgs, Base } from "igniteui-react-core/ES2015/type";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { Brush } from "igniteui-react-core/ES2015/Brush";
import { IDomainChartWidget } from "./IDomainChartWidget";
import { XamDataChart } from "./XamDataChart";
import { DataSeriesAdapterImplementation } from "igniteui-react-core/ES2015/DataSeriesAdapterImplementation";
import { DataSeriesType } from "igniteui-react-core/ES2015/DataSeriesType";
import { IDataSeriesAdapterRule } from "igniteui-react-core/ES2015/IDataSeriesAdapterRule";
import { MarkerType } from "./MarkerType";
import { Color } from "igniteui-react-core/ES2015/Color";
import { BrushCollection } from "igniteui-react-core/ES2015/BrushCollection";
import { IChartLegend } from "igniteui-react-core/ES2015/IChartLegend";
import { Rect } from "igniteui-react-core/ES2015/Rect";
import { HorizontalAlignment } from "igniteui-react-core/ES2015/HorizontalAlignment";
import { UnknownValuePlotting } from "igniteui-react-core/ES2015/UnknownValuePlotting";
import { MarkerTypeCollection } from "./MarkerTypeCollection";
import { TrendLineType } from "igniteui-react-core/ES2015/TrendLineType";
import { Series } from "./Series";
import { ObservableCollection$1 } from "igniteui-react-core/ES2015/ObservableCollection$1";
import { DataSeries } from "igniteui-react-core/ES2015/DataSeries";
import { DataSeriesMarker } from "igniteui-react-core/ES2015/DataSeriesMarker";
import { ChartSeriesEventArgs } from "./ChartSeriesEventArgs";
import { DomainChartSeriesPointerEventArgs } from "./DomainChartSeriesPointerEventArgs";
export declare abstract class DomainChart extends Base implements INotifyPropertyChanged {
    protected cn: any;
    provideContainer(a: any): void;
    destroy(): void;
    private e1;
    protected e2(): void;
    protected ey(a: XamDataChart): void;
    protected ev(): void;
    protected e4(a: Series, b: number): void;
    protected fl(a: string, b: any, c: any): void;
    private cm;
    tooltipTemplate: any;
    private a6;
    tooltipTemplates: List$1<any>;
    private bi;
    by: number;
    private cl;
    private toolTip;
    private br;
    b7: number;
    private bs;
    b8: number;
    private bt;
    b9: number;
    private bq;
    b6: number;
    private bm;
    b2: number;
    private bo;
    b4: number;
    private bn;
    b3: number;
    private bl;
    b1: number;
    private ga;
    gg: Brush;
    private gb;
    gh: Brush;
    private bh;
    protected get_bx(): number;
    protected set_bx(a: number): void;
    bx: number;
    private bu;
    ca: number;
    private bk;
    b0: number;
    private bg;
    bw: number;
    private cg;
    cj: number;
    private an;
    ao: (time: number) => number;
    protected ez(a: XamDataChart): void;
    protected e5(a: Series, b: number): void;
    protected ew(): void;
    private e6;
    cc: (arg1: Element) => any[];
    private f5;
    private cp;
    private a4;
    private cd;
    protected fm(a: string, b: any, c: any): void;
    private aa;
    ab: IDomainChartWidget;
    private cw;
    du: string;
    private cy;
    d5: string;
    private al;
    dataChart: XamDataChart;
    s: DataSeriesAdapterImplementation;
    constructor();
    protected e0(): void;
    protected abstract readonly bb: List$1<DataSeriesType>;
    protected abstract readonly ba: List$1<IDataSeriesAdapterRule>;
    protected a9: List$1<MarkerType>;
    protected a0(a: DataSeriesType): boolean;
    notifyResized(): void;
    fe(): void;
    eq(): void;
    et(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected fq(a: string): void;
    protected er(a: (arg1: Series) => void): void;
    protected es(a: (arg1: Series, arg2: number) => void): void;
    protected ff(a: (arg1: XamDataChart) => void): void;
    protected fg(a: (arg1: XamDataChart) => void, b: boolean): void;
    protected fh(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    protected a1(a: DataSeries): boolean;
    protected ax(): boolean;
    private static readonly cu;
    private cf;
    protected c6(a: DataSeries): string;
    protected c7(a: DataSeries, b: DataSeriesType): string;
    protected abstract r(a: DataSeries): DataSeriesType;
    protected abstract ag(a: DataSeries, b: DataSeriesType): Series;
    c5(): string;
    private az;
    protected f1(): void;
    protected abstract f0(a: DataSeries): void;
    protected abstract fz(a: DataSeries): void;
    protected f3(): void;
    protected f4(a: Series): void;
    protected abstract f2(): void;
    private fi;
    protected gc(a: number): Brush;
    protected gf(a: number): Brush;
    protected gd(a: number): Brush;
    protected ge(a: number): Brush;
    protected gi(a: number): Color;
    protected bf(a: Color): ObservableCollection$1<Color>;
    protected k(a: Color): BrushCollection;
    protected a5: List$1<Color>;
    protected readonly a7: List$1<Color>;
    co(): any;
    e7(a: string, b: string): void;
    e8(a: string, b: string, c: Series): void;
    ac(a: DataSeriesMarker): MarkerType;
    fd(source_: any, a: number, b: any, c: any): void;
    e9(source_: any): void;
    fa(source_: any, a: number, b: any): void;
    fb(source_: any, a: number, b: any): void;
    seriesAdded: (sender: any, args: ChartSeriesEventArgs) => void;
    fr(a: Series): void;
    seriesRemoved: (sender: any, args: ChartSeriesEventArgs) => void;
    fx(a: Series): void;
    seriesPointerEnter: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    ft(a: Series, b: any): void;
    seriesPointerLeave: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    fu(a: Series, b: any): void;
    seriesPointerMove: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    fv(a: Series, b: any): void;
    seriesPointerDown: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    fs(a: Series, b: any): void;
    seriesPointerUp: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    fw(a: Series, b: any): void;
    private a8;
    fo(a: () => void): void;
    fp(a: () => void, b: boolean): {
        p1?: boolean;
    };
    protected get_a2(): boolean;
    protected readonly a2: boolean;
    protected ex(a: XamDataChart): void;
    protected e3(a: Series, b: number): void;
    protected abstract en(): void;
    protected readonly aw: boolean;
    private ar;
    protected ep(): void;
    protected eu(): void;
    protected abstract fy(a: XamDataChart): void;
    private em;
    protected abstract el(a: Series, b: number): void;
    protected ad(a: Series, b: number): MarkerType;
    protected fk(a: string, b: any, c: any): void;
    private fj;
    private bd;
    itemsSource: IEnumerable;
    private b;
    d: string[];
    private a;
    c: string[];
    private e;
    j: BrushCollection;
    private h;
    n: BrushCollection;
    private y;
    legend: IChartLegend;
    private as;
    protected get_ay(): boolean;
    protected set_ay(a: boolean): void;
    ay: boolean;
    private at;
    protected get_a3(): boolean;
    protected set_a3(a: boolean): void;
    a3: boolean;
    private gj;
    gl: Rect;
    readonly gk: Rect;
    private cx;
    dy: string;
    private cv;
    dm: string;
    private f7;
    f9: HorizontalAlignment;
    private f6;
    f8: HorizontalAlignment;
    private aj;
    ak: UnknownValuePlotting;
    private bj;
    protected get_bz(): number;
    protected set_bz(a: number): void;
    bz: number;
    private bp;
    b5: number;
    private ae;
    af: MarkerTypeCollection;
    private f;
    l: BrushCollection;
    private g;
    m: BrushCollection;
    private ce;
    ci: number;
    private aq;
    av: boolean;
    private i;
    o: BrushCollection;
    private ah;
    ai: TrendLineType;
    private bv;
    cb: number;
    private ap;
    au: boolean;
    private ch;
    ck: number;
    static $t: Type;
}
