/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { HorizontalAlignment_$type } from "igniteui-react-core/ES2015/HorizontalAlignment";
import { VerticalAlignment_$type } from "igniteui-react-core/ES2015/VerticalAlignment";
import { Visibility_$type } from "igniteui-react-core/ES2015/Visibility";
import { AxisLabelsLocation_$type } from "./AxisLabelsLocation";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core/ES2015/type";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
export class XYChart extends DomainChart {
    constructor() {
        super(...arguments);
        this.go = null;
        this.gp = null;
        this.g1 = 0;
        this.g3 = 5;
        this.g2 = 0;
        this.g0 = 5;
        this.hi = 5;
        this.hk = 0;
        this.hj = 5;
        this.hh = 0;
        this.ly = null;
        this.l5 = null;
        this.hc = 0;
        this.ht = 0;
        this.hb = NaN;
        this.hs = NaN;
        this.he = NaN;
        this.hv = NaN;
        this.hd = NaN;
        this.hu = NaN;
        this.ha = NaN;
        this.hr = NaN;
        this.l4 = null;
        this.mb = null;
        this.i4 = null;
        this.i7 = null;
        this.i6 = null;
        this.i9 = null;
        this.i0 = null;
        this.i1 = null;
        this.lz = null;
        this.l6 = null;
        this.g4 = 1;
        this.hl = 1;
        this.g5 = 1;
        this.hm = 0;
        this.l1 = null;
        this.l8 = null;
        this.l2 = null;
        this.l9 = null;
        this.g6 = 1;
        this.hn = 1;
        this.g7 = 5;
        this.ho = 0;
        this.l3 = null;
        this.ma = null;
        this.g8 = 2;
        this.hp = 2;
        this.i5 = null;
        this.i8 = null;
        this.l0 = null;
        this.l7 = null;
        this.gz = 0;
        this.hg = 0;
        this.gy = NaN;
        this.hf = NaN;
        this.g9 = 0;
        this.hq = -90;
        this.gu = false;
        this.gv = false;
        this.lt = 1;
        this.ms = 1;
        this.ls = 1;
        this.lu = 2;
        this.mq = 0;
        this.mr = 1;
        this.mw = 0;
        this.mx = 0;
        this.gs = 2;
    }
    provideContainer(a) {
        if (a != null) {
            let b = this.gm();
            let c = this.gn();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        super.provideContainer(a);
    }
    e2() {
        super.e2();
        let a = this.gm();
        let b = this.gn();
        if (a != null && a.aw != null) {
            this.mc = a.aw.textColor;
        }
        if (b != null && b.aw != null) {
            this.mj = b.aw.textColor;
        }
    }
    fl(a, b, c) {
        super.fl(a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.lm((d) => d.leftMargin = this.h3);
                break;
            case "XAxisLabelTopMargin":
                this.lm((d) => d.topMargin = this.h5);
                break;
            case "XAxisLabelRightMargin":
                this.lm((d) => d.rightMargin = this.h4);
                break;
            case "XAxisLabelBottomMargin":
                this.lm((d) => d.bottomMargin = this.h2);
                break;
            case "YAxisLabelLeftMargin":
                this.lq((d) => d.leftMargin = this.il);
                break;
            case "YAxisLabelTopMargin":
                this.lq((d) => d.topMargin = this.io);
                break;
            case "YAxisLabelRightMargin":
                this.lq((d) => d.rightMargin = this.im);
                break;
            case "YAxisLabelBottomMargin":
                this.lq((d) => d.bottomMargin = this.ik);
                break;
            case "XAxisLabelTextColor":
                this.lm((d) => d.textColor = this.mc);
                break;
            case "YAxisLabelTextColor":
                this.lq((d) => d.textColor = this.mj);
                break;
            case "XAxisTitleMargin":
                this.ln((d) => d.margin = this.ie);
                break;
            case "YAxisTitleMargin":
                this.lr((d) => d.margin = this.ix);
                break;
            case "XAxisTitleLeftMargin":
                this.ln((d) => d.leftMargin = this.id);
                break;
            case "YAxisTitleLeftMargin":
                this.lr((d) => d.leftMargin = this.iw);
                break;
            case "XAxisTitleTopMargin":
                this.ln((d) => d.topMargin = this.ih);
                break;
            case "YAxisTitleTopMargin":
                this.lr((d) => d.topMargin = this.iz);
                break;
            case "XAxisTitleRightMargin":
                this.ln((d) => d.rightMargin = this.ig);
                break;
            case "YAxisTitleRightMargin":
                this.lr((d) => d.rightMargin = this.iy);
                break;
            case "XAxisTitleBottomMargin":
                this.ln((d) => d.bottomMargin = this.ic);
                break;
            case "YAxisTitleBottomMargin":
                this.lr((d) => d.bottomMargin = this.iv);
                break;
            case "XAxisTitleTextColor":
                this.ln((d) => d.textColor = this.mi);
                break;
            case "YAxisTitleTextColor":
                this.lr((d) => d.textColor = this.mp);
                break;
            case "XAxisFormatLabel":
                this.lk((d) => d.ar = this.gq);
                break;
            case "YAxisFormatLabel":
                this.lo((d) => d.ar = this.gr);
                break;
        }
    }
    get gq() {
        return this.go;
    }
    set gq(a) {
        let b = this.gq;
        if (a != b) {
            this.go = a;
            this.fk("XAxisFormatLabel", b, this.gq);
        }
    }
    get gr() {
        return this.gp;
    }
    set gr(a) {
        let b = this.gr;
        if (a != b) {
            this.gp = a;
            this.fk("YAxisFormatLabel", b, this.gr);
        }
    }
    get h3() {
        return this.g1;
    }
    set h3(a) {
        let b = this.h3;
        if (a != b) {
            this.g1 = a;
            this.fk("XAxisLabelLeftMargin", b, this.h3);
        }
    }
    get h5() {
        return this.g3;
    }
    set h5(a) {
        let b = this.h5;
        if (a != b) {
            this.g3 = a;
            this.fk("XAxisLabelTopMargin", b, this.h5);
        }
    }
    get h4() {
        return this.g2;
    }
    set h4(a) {
        let b = this.h4;
        if (a != b) {
            this.g2 = a;
            this.fk("XAxisLabelRightMargin", b, this.h4);
        }
    }
    get h2() {
        return this.g0;
    }
    set h2(a) {
        let b = this.h2;
        if (a != b) {
            this.g0 = a;
            this.fk("XAxisLabelBottomMargin", b, this.h2);
        }
    }
    get il() {
        return this.hi;
    }
    set il(a) {
        let b = this.il;
        if (a != b) {
            this.hi = a;
            this.fk("YAxisLabelLeftMargin", b, this.il);
        }
    }
    get io() {
        return this.hk;
    }
    set io(a) {
        let b = this.io;
        if (a != b) {
            this.hk = a;
            this.fk("YAxisLabelTopMargin", b, this.io);
        }
    }
    get im() {
        return this.hj;
    }
    set im(a) {
        let b = this.im;
        if (a != b) {
            this.hj = a;
            this.fk("YAxisLabelRightMargin", b, this.im);
        }
    }
    get ik() {
        return this.hh;
    }
    set ik(a) {
        let b = this.ik;
        if (a != b) {
            this.hh = a;
            this.fk("YAxisLabelBottomMargin", b, this.ik);
        }
    }
    get mc() {
        return this.ly;
    }
    set mc(a) {
        let b = this.mc;
        if (a != b) {
            this.ly = a;
            this.fk("XAxisLabelTextColor", b, this.mc);
        }
    }
    get mj() {
        return this.l5;
    }
    set mj(a) {
        let b = this.mj;
        if (a != b) {
            this.l5 = a;
            this.fk("YAxisLabelTextColor", b, this.mj);
        }
    }
    get ie() {
        return this.hc;
    }
    set ie(a) {
        let b = this.ie;
        if (a != b) {
            this.hc = a;
            this.fk("XAxisTitleMargin", b, this.ie);
        }
    }
    get ix() {
        return this.ht;
    }
    set ix(a) {
        let b = this.ix;
        if (a != b) {
            this.ht = a;
            this.fk("YAxisTitleMargin", b, this.ix);
        }
    }
    get id() {
        return this.hb;
    }
    set id(a) {
        let b = this.id;
        if (a != b) {
            this.hb = a;
            this.fk("XAxisTitleLeftMargin", b, this.id);
        }
    }
    get iw() {
        return this.hs;
    }
    set iw(a) {
        let b = this.iw;
        if (a != b) {
            this.hs = a;
            this.fk("YAxisTitleLeftMargin", b, this.iw);
        }
    }
    get ih() {
        return this.he;
    }
    set ih(a) {
        let b = this.ih;
        if (a != b) {
            this.he = a;
            this.fk("XAxisTitleTopMargin", b, this.ih);
        }
    }
    get iz() {
        return this.hv;
    }
    set iz(a) {
        let b = this.iz;
        if (a != b) {
            this.hv = a;
            this.fk("YAxisTitleTopMargin", b, this.iz);
        }
    }
    get ig() {
        return this.hd;
    }
    set ig(a) {
        let b = this.ig;
        if (a != b) {
            this.hd = a;
            this.fk("XAxisTitleRightMargin", b, this.ig);
        }
    }
    get iy() {
        return this.hu;
    }
    set iy(a) {
        let b = this.iy;
        if (a != b) {
            this.hu = a;
            this.fk("YAxisTitleRightMargin", b, this.iy);
        }
    }
    get ic() {
        return this.ha;
    }
    set ic(a) {
        let b = this.ic;
        if (a != b) {
            this.ha = a;
            this.fk("XAxisTitleBottomMargin", b, this.ic);
        }
    }
    get iv() {
        return this.hr;
    }
    set iv(a) {
        let b = this.iv;
        if (a != b) {
            this.hr = a;
            this.fk("YAxisTitleBottomMargin", b, this.iv);
        }
    }
    get mi() {
        return this.l4;
    }
    set mi(a) {
        let b = this.mi;
        if (a != b) {
            this.l4 = a;
            this.fk("XAxisTitleTextColor", b, this.mi);
        }
    }
    get mp() {
        return this.mb;
    }
    set mp(a) {
        let b = this.mp;
        if (a != b) {
            this.mb = a;
            this.fk("YAxisTitleTextColor", b, this.mp);
        }
    }
    fm(a, b, c) {
        super.fm(a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.lm((d) => d.textStyle = this.jl);
                break;
            case "YAxisLabelTextStyle":
                this.lq((d) => d.textStyle = this.kn);
                break;
            case "XAxisTitleTextStyle":
                this.ln((d) => d.textStyle = this.j9);
                break;
            case "YAxisTitleTextStyle":
                this.lr((d) => d.textStyle = this.lb);
                break;
        }
    }
    get jl() {
        return this.i4;
    }
    set jl(a) {
        let b = this.jl;
        if (a != b) {
            this.i4 = a;
            this.fk("XAxisLabelTextStyle", b, this.jl);
        }
    }
    get kn() {
        return this.i7;
    }
    set kn(a) {
        let b = this.kn;
        if (a != b) {
            this.i7 = a;
            this.fk("YAxisLabelTextStyle", b, this.kn);
        }
    }
    get j9() {
        return this.i6;
    }
    set j9(a) {
        let b = this.j9;
        if (a != b) {
            this.i6 = a;
            this.fk("XAxisTitleTextStyle", b, this.j9);
        }
    }
    get lb() {
        return this.i9;
    }
    set lb(a) {
        let b = this.lb;
        if (a != b) {
            this.i9 = a;
            this.fk("YAxisTitleTextStyle", b, this.lb);
        }
    }
    lh(a) {
        this.le(a, (b) => b.leftMargin = this.h3);
        this.le(a, (b) => b.topMargin = this.h5);
        this.le(a, (b) => b.rightMargin = this.h4);
        this.le(a, (b) => b.bottomMargin = this.h2);
        this.le(a, (b) => b.textColor = this.mc);
        this.lf(a, (b) => b.textColor = this.mi);
        this.lf(a, (b) => b.leftMargin = this.id);
        this.lf(a, (b) => b.topMargin = this.ih);
        this.lf(a, (b) => b.rightMargin = this.ig);
        this.lf(a, (b) => b.bottomMargin = this.ic);
        this.le(a, (b) => b.textStyle = this.jl);
        this.lf(a, (b) => b.textStyle = this.j9);
    }
    lj(a) {
        this.le(a, (b) => b.leftMargin = this.il);
        this.le(a, (b) => b.topMargin = this.io);
        this.le(a, (b) => b.rightMargin = this.im);
        this.le(a, (b) => b.bottomMargin = this.ik);
        this.le(a, (b) => b.textColor = this.mj);
        this.lf(a, (b) => b.textColor = this.mp);
        this.lf(a, (b) => b.leftMargin = this.iw);
        this.lf(a, (b) => b.topMargin = this.iz);
        this.lf(a, (b) => b.rightMargin = this.iy);
        this.lf(a, (b) => b.bottomMargin = this.iv);
        this.le(a, (b) => b.textStyle = this.kn);
        this.lf(a, (b) => b.textStyle = this.lb);
    }
    f0(a) {
        let b = this.r(a);
        let c = this.ag(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        c.name = this.c6(a);
        c.fr = this.c7(a, b);
        this.dataChart.series.add(c);
    }
    lk(a) {
        this.ll(a, null);
    }
    ll(a, b) {
        a(this.gm());
    }
    lp(a, b) {
        a(this.gn());
    }
    lo(a) {
        this.lp(a, true);
    }
    ln(a) {
        this.lf(this.gm(), a);
    }
    lr(a) {
        this.lf(this.gn(), a);
    }
    lq(a) {
        this.le(this.gn(), a);
    }
    lm(a) {
        this.le(this.gm(), a);
    }
    hw(a) {
        let b = this.gm();
        return b.dt(a, new ScalerParams(1, this.gl, this.gk, b.b8));
    }
    hy(a) {
        let b = this.gm();
        return b.dw(a, new ScalerParams(1, this.gl, this.gk, b.b8));
    }
    hx(a) {
        let b = this.gn();
        return b.dt(a, new ScalerParams(1, this.gl, this.gk, b.b8));
    }
    hz(a) {
        let b = this.gn();
        return b.dw(a, new ScalerParams(1, this.gl, this.gk, b.b8));
    }
    fy(a) {
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            let b = this.gm();
            let c = this.gn();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    }
    static ja(a, b) {
        for (let c of fromEnum(b)) {
            let d = c.findMatchingHint(16);
            if (d != null) {
                let e = d.path;
                return e;
            }
        }
        return null;
    }
    ex(a) {
        super.ex(a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.gm());
            this.dataChart.axes.add(this.gn());
        }
    }
    lg(a) {
        if (a != null && this.cn != null && a.ep == null) {
            a.provideRenderer(this.cn);
        }
        a.ic = this.md;
        a.d0 = this.h6;
        a.id = this.me;
        a.d3 = this.h7;
        a.ig = this.mg;
        a.ek = this.h8;
        a.ie = this.mf;
        a.el = this.h9;
        a.ih = this.mh;
        a.em = this.ia;
        a.cn = true;
        let b = a == this.gm();
        if (b) {
            a.f1 = this.j0;
        }
        a.e2 = this.i2;
        this.le(a, (c) => c.angle = this.h1);
        this.le(a, (c) => {
            if (c.extent != this.h0) {
                c.extent = this.h0;
            }
        });
        this.le(a, (c) => c.horizontalAlignment = this.lv);
        this.le(a, (c) => c.verticalAlignment = this.mt);
        this.le(a, (c) => c.visibility = this.my);
        this.lf(a, (c) => c.horizontalAlignment = this.lw);
        this.lf(a, (c) => c.angle = this.ib);
        this.lh(a);
    }
    li(a) {
        if (a == null) {
            return;
        }
        if (this.cn != null && a.ep == null) {
            a.provideRenderer(this.cn);
        }
        this.le(a, (b) => b.angle = this.ij);
        this.le(a, (b) => {
            if (b.extent != this.ii) {
                b.extent = this.ii;
            }
        });
        this.le(a, (b) => b.horizontalAlignment = this.lx);
        this.le(a, (b) => b.verticalAlignment = this.mu);
        this.le(a, (b) => b.visibility = this.mz);
        this.le(a, (b) => b.location = this.gt);
        this.lf(a, (b) => b.verticalAlignment = this.mv);
        this.lf(a, (b) => b.angle = this.iu);
        a.ic = this.mk;
        a.d0 = this.ip;
        a.id = this.ml;
        a.d3 = this.iq;
        a.ig = this.mn;
        a.ek = this.ir;
        a.ie = this.mm;
        a.el = this.is;
        a.ih = this.mo;
        a.em = this.it;
        let b = a == this.gn();
        if (b) {
            a.f1 = this.k2;
        }
        this.lj(a);
    }
    eu() {
        super.eu();
        this.lg(this.gm());
        this.li(this.gn());
    }
    le(a, b) {
        if (a == null) {
            return;
        }
        if (a.aw == null) {
            a.aw = new AxisLabelSettings();
            a.aw.angle = a.dh();
            a.aw.bottomMargin = a.di();
            a.aw.leftMargin = a.dj();
            a.aw.rightMargin = a.dk();
            a.aw.topMargin = a.dl();
            a.aw.horizontalAlignment = a.h7();
            a.aw.location = a.ax();
            a.aw.verticalAlignment = a.i1();
        }
        b(a.aw);
    }
    lf(a, b) {
        if (a == null) {
            return;
        }
        if (a.bc == null) {
            a.bc = new TitleSettings();
            a.bc.bottomMargin = a.dn();
            a.bc.leftMargin = a.dp();
            a.bc.rightMargin = a.dq();
            a.bc.topMargin = a.dr();
            a.bc.location = a.ay();
            a.bc.angle = a.dm();
            a.bc.horizontalAlignment = a.h8();
            a.bc.verticalAlignment = a.i2();
        }
        b(a.bc);
    }
    fk(a, b, c) {
        super.fk(a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.lm((d) => d.angle = this.h1);
                break;
            case "YAxisLabelAngle":
                this.lq((d) => d.angle = this.ij);
                break;
            case "XAxisLabelHorizontalAlignment":
                this.lm((d) => d.horizontalAlignment = this.lv);
                break;
            case "YAxisLabelHorizontalAlignment":
                this.lq((d) => d.horizontalAlignment = this.lx);
                break;
            case "XAxisLabelVerticalAlignment":
                this.lm((d) => d.verticalAlignment = this.mt);
                break;
            case "YAxisLabelVerticalAlignment":
                this.lq((d) => d.verticalAlignment = this.mu);
                break;
            case "XAxisLabelVisibility":
                this.lm((d) => d.visibility = this.my);
                break;
            case "YAxisLabelVisibility":
                this.lq((d) => d.visibility = this.mz);
                break;
            case "XAxisLabel":
                this.lk((d) => d.e2 = this.i2);
                break;
            case "YAxisLabel":
                this.lo((d) => d.e2 = this.i3);
                break;
            case "XAxisTitleAngle":
                this.ln((d) => d.angle = this.ib);
                break;
            case "YAxisTitleAngle":
                this.lr((d) => d.angle = this.iu);
                break;
            case "XAxisTitleAlignment":
                this.ln((d) => d.horizontalAlignment = this.lw);
                break;
            case "YAxisTitleAlignment":
                this.lr((d) => d.verticalAlignment = this.mv);
                break;
            case "XAxisTitle":
                this.lk((d) => d.f1 = this.j0);
                break;
            case "YAxisTitle":
                this.lp((d) => d.f1 = this.k2, false);
                break;
            case "XAxisMajorStroke":
                this.ll((d) => d.ic = this.md, a);
                break;
            case "YAxisMajorStroke":
                this.lo((d) => d.ic = this.mk);
                break;
            case "XAxisMajorStrokeThickness":
                this.ll((d) => d.d0 = this.h6, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.lo((d) => d.d0 = this.ip);
                break;
            case "XAxisMinorStroke":
                this.lk((d) => d.id = this.me);
                break;
            case "YAxisMinorStroke":
                this.lo((d) => d.id = this.ml);
                break;
            case "XAxisMinorStrokeThickness":
                this.lk((d) => d.d3 = this.h7);
                break;
            case "YAxisMinorStrokeThickness":
                this.lo((d) => d.d3 = this.iq);
                break;
            case "XAxisTickLength":
                this.lk((d) => d.el = this.h9);
                break;
            case "YAxisTickLength":
                this.lo((d) => d.el = this.is);
                break;
            case "XAxisTickStroke":
                this.lk((d) => d.ih = this.mh);
                break;
            case "YAxisTickStroke":
                this.lo((d) => d.ih = this.mo);
                break;
            case "XAxisTickStrokeThickness":
                this.lk((d) => d.em = this.ia);
                break;
            case "YAxisTickStrokeThickness":
                this.lo((d) => d.em = this.it);
                break;
            case "XAxisStroke":
                this.lk((d) => d.ig = this.mg);
                break;
            case "YAxisStroke":
                this.lo((d) => d.ig = this.mn);
                break;
            case "XAxisStrokeThickness":
                this.lk((d) => d.ek = this.h8);
                break;
            case "YAxisStrokeThickness":
                this.lo((d) => d.ek = this.ir);
                break;
            case "XAxisExtent":
                this.lm((d) => d.extent = this.h0);
                break;
            case "YAxisExtent":
                this.lq((d) => d.extent = this.ii);
                break;
            case "XAxisStrip":
                this.lk((d) => d.ie = this.mf);
                break;
            case "YAxisStrip":
                this.lo((d) => d.ie = this.mm);
                break;
            case "XAxisInverted":
                this.lk((d) => d.b8 = this.gw);
                break;
            case "YAxisInverted":
                this.lo((d) => d.b8 = this.gx);
                break;
            case "YAxisLabelLocation":
                this.lq((d) => d.location = this.gt);
                break;
        }
    }
    get i2() {
        return this.i0;
    }
    set i2(a) {
        let b = this.i2;
        if (a != b) {
            this.i0 = a;
            this.fk("XAxisLabel", b, this.i2);
        }
    }
    get i3() {
        return this.i1;
    }
    set i3(a) {
        let b = this.i3;
        if (a != b) {
            this.i1 = a;
            this.fk("YAxisLabel", b, this.i3);
        }
    }
    get md() {
        return this.lz;
    }
    set md(a) {
        let b = this.md;
        if (a != b) {
            this.lz = a;
            this.fk("XAxisMajorStroke", b, this.md);
        }
    }
    get mk() {
        return this.l6;
    }
    set mk(a) {
        let b = this.mk;
        if (a != b) {
            this.l6 = a;
            this.fk("YAxisMajorStroke", b, this.mk);
        }
    }
    get h6() {
        return this.g4;
    }
    set h6(a) {
        let b = this.h6;
        if (a != b) {
            this.g4 = a;
            this.fk("XAxisMajorStrokeThickness", b, this.h6);
        }
    }
    get ip() {
        return this.hl;
    }
    set ip(a) {
        let b = this.ip;
        if (a != b) {
            this.hl = a;
            this.fk("YAxisMajorStrokeThickness", b, this.ip);
        }
    }
    get h7() {
        return this.g5;
    }
    set h7(a) {
        let b = this.h7;
        if (a != b) {
            this.g5 = a;
            this.fk("XAxisMinorStrokeThickness", b, this.h7);
        }
    }
    get iq() {
        return this.hm;
    }
    set iq(a) {
        let b = this.iq;
        if (a != b) {
            this.hm = a;
            this.fk("YAxisMinorStrokeThickness", b, this.iq);
        }
    }
    get mf() {
        return this.l1;
    }
    set mf(a) {
        let b = this.mf;
        if (a != b) {
            this.l1 = a;
            this.fk("XAxisStrip", b, this.mf);
        }
    }
    get mm() {
        return this.l8;
    }
    set mm(a) {
        let b = this.mm;
        if (a != b) {
            this.l8 = a;
            this.fk("YAxisStrip", b, this.mm);
        }
    }
    get mg() {
        return this.l2;
    }
    set mg(a) {
        let b = this.mg;
        if (a != b) {
            this.l2 = a;
            this.fk("XAxisStroke", b, this.mg);
        }
    }
    get mn() {
        return this.l9;
    }
    set mn(a) {
        let b = this.mn;
        if (a != b) {
            this.l9 = a;
            this.fk("YAxisStroke", b, this.mn);
        }
    }
    get h8() {
        return this.g6;
    }
    set h8(a) {
        let b = this.h8;
        if (a != b) {
            this.g6 = a;
            this.fk("XAxisStrokeThickness", b, this.h8);
        }
    }
    get ir() {
        return this.hn;
    }
    set ir(a) {
        let b = this.ir;
        if (a != b) {
            this.hn = a;
            this.fk("YAxisStrokeThickness", b, this.ir);
        }
    }
    get h9() {
        return this.g7;
    }
    set h9(a) {
        let b = this.h9;
        if (a != b) {
            this.g7 = a;
            this.fk("XAxisTickLength", b, this.h9);
        }
    }
    get is() {
        return this.ho;
    }
    set is(a) {
        let b = this.is;
        if (a != b) {
            this.ho = a;
            this.fk("YAxisTickLength", b, this.is);
        }
    }
    get mh() {
        return this.l3;
    }
    set mh(a) {
        let b = this.mh;
        if (a != b) {
            this.l3 = a;
            this.fk("XAxisTickStroke", b, this.mh);
        }
    }
    get mo() {
        return this.ma;
    }
    set mo(a) {
        let b = this.mo;
        if (a != b) {
            this.ma = a;
            this.fk("YAxisTickStroke", b, this.mo);
        }
    }
    get ia() {
        return this.g8;
    }
    set ia(a) {
        let b = this.ia;
        if (a != b) {
            this.g8 = a;
            this.fk("XAxisTickStrokeThickness", b, this.ia);
        }
    }
    get it() {
        return this.hp;
    }
    set it(a) {
        let b = this.it;
        if (a != b) {
            this.hp = a;
            this.fk("YAxisTickStrokeThickness", b, this.it);
        }
    }
    get j0() {
        return this.i5;
    }
    set j0(a) {
        let b = this.j0;
        if (a != b) {
            this.i5 = a;
            this.fk("XAxisTitle", b, this.j0);
        }
    }
    get k2() {
        return this.i8;
    }
    set k2(a) {
        let b = this.k2;
        if (a != b) {
            this.i8 = a;
            this.fk("YAxisTitle", b, this.k2);
        }
    }
    get me() {
        return this.l0;
    }
    set me(a) {
        let b = this.me;
        if (a != b) {
            this.l0 = a;
            this.fk("XAxisMinorStroke", b, this.me);
        }
    }
    get ml() {
        return this.l7;
    }
    set ml(a) {
        let b = this.ml;
        if (a != b) {
            this.l7 = a;
            this.fk("YAxisMinorStroke", b, this.ml);
        }
    }
    get h1() {
        return this.gz;
    }
    set h1(a) {
        let b = this.h1;
        if (a != b) {
            this.gz = a;
            this.fk("XAxisLabelAngle", b, this.h1);
        }
    }
    get ij() {
        return this.hg;
    }
    set ij(a) {
        let b = this.ij;
        if (a != b) {
            this.hg = a;
            this.fk("YAxisLabelAngle", b, this.ij);
        }
    }
    get h0() {
        return this.gy;
    }
    set h0(a) {
        let b = this.h0;
        if (a != b) {
            this.gy = a;
            this.fk("XAxisExtent", b, this.h0);
        }
    }
    get ii() {
        return this.hf;
    }
    set ii(a) {
        let b = this.ii;
        if (a != b) {
            this.hf = a;
            this.fk("YAxisExtent", b, this.ii);
        }
    }
    get ib() {
        return this.g9;
    }
    set ib(a) {
        let b = this.ib;
        if (a != b) {
            this.g9 = a;
            this.fk("XAxisTitleAngle", b, this.ib);
        }
    }
    get iu() {
        return this.hq;
    }
    set iu(a) {
        let b = this.iu;
        if (a != b) {
            this.hq = a;
            this.fk("YAxisTitleAngle", b, this.iu);
        }
    }
    get gw() {
        return this.gu;
    }
    set gw(a) {
        let b = this.gw;
        if (a != b) {
            this.gu = a;
            this.fk("XAxisInverted", b, this.gw);
        }
    }
    get gx() {
        return this.gv;
    }
    set gx(a) {
        let b = this.gx;
        if (a != b) {
            this.gv = a;
            this.fk("YAxisInverted", b, this.gx);
        }
    }
    get lw() {
        return this.lt;
    }
    set lw(a) {
        let b = this.lw;
        if (a != b) {
            this.lt = a;
            this.fk("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.lw));
        }
    }
    get mv() {
        return this.ms;
    }
    set mv(a) {
        let b = this.mv;
        if (a != b) {
            this.ms = a;
            this.fk("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.mv));
        }
    }
    get lv() {
        return this.ls;
    }
    set lv(a) {
        let b = this.lv;
        if (a != b) {
            this.ls = a;
            this.fk("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.lv));
        }
    }
    get_lx() {
        return this.lu;
    }
    set_lx(a) {
        let b = this.lx;
        if (a != b) {
            this.lu = a;
            this.fk("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.lx));
        }
    }
    get lx() {
        return this.get_lx();
    }
    set lx(a) {
        this.set_lx(a);
    }
    get mt() {
        return this.mq;
    }
    set mt(a) {
        let b = this.mt;
        if (a != b) {
            this.mq = a;
            this.fk("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.mt));
        }
    }
    get mu() {
        return this.mr;
    }
    set mu(a) {
        let b = this.mu;
        if (a != b) {
            this.mr = a;
            this.fk("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.mu));
        }
    }
    get my() {
        return this.mw;
    }
    set my(a) {
        let b = this.my;
        if (a != b) {
            this.mw = a;
            this.fk("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.my));
        }
    }
    get mz() {
        return this.mx;
    }
    set mz(a) {
        let b = this.mz;
        if (a != b) {
            this.mx = a;
            this.fk("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.mz));
        }
    }
    get_gt() {
        return this.gs;
    }
    set_gt(a) {
        let b = this.gt;
        if (a != b) {
            this.gs = a;
            this.fk("YAxisLabelLocation", enumGetBox(AxisLabelsLocation_$type, b), enumGetBox(AxisLabelsLocation_$type, this.gt));
        }
    }
    get gt() {
        return this.get_gt();
    }
    set gt(a) {
        this.set_gt(a);
    }
}
XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
